package org.jboss.security;

package .tmp;

import java.util.ArrayList;
import org.jboss.security.RunAsIdentity;
import org.jboss.security.SecurityAssociation;

class RunAsThreadLocalStack {
  ThreadLocal local;
  
  RunAsThreadLocalStack(boolean threadLocal) {
    if (threadLocal == true) {
      this.local = (ThreadLocal)new SecurityAssociation.ArrayListLocal(null);
    } else {
      this.local = (ThreadLocal)new SecurityAssociation.ArrayListInheritableLocal(null);
    } 
  }
  
  void push(RunAsIdentity runAs) {
    ArrayList stack = this.local.get();
    stack.add(runAs);
  }
  
  RunAsIdentity pop() {
    ArrayList stack = this.local.get();
    RunAsIdentity runAs = null;
    int lastIndex = stack.size() - 1;
    if (lastIndex >= 0)
      runAs = stack.remove(lastIndex); 
    return runAs;
  }
  
  RunAsIdentity peek(int depth) {
    ArrayList stack = this.local.get();
    RunAsIdentity runAs = null;
    int stackSize = stack.size();
    do {
      int index = stackSize - 1 - depth;
      if (index >= 0)
        runAs = stack.get(index); 
      depth++;
    } while (runAs == null && depth <= stackSize - 1);
    return runAs;
  }
}
